;-- 515_4AIN (Analog-Tests fuer MKTs EA515-Modul 4*A.in ) -------------------
;        lauffhig nur mit WoBu's "CAN-TESTER FUER WINDOWS" !
; Autor: Wolfgang Bscher
; Stand: 2012-06-04 (ISO-Datum: YYYY-MM-DD)
; Datei: C:\cbproj\CanTest\Programs\515_4ain.txt
;
; Hinweis: Fr einen EMV-Test anno 2012, mit 4 D/A + 4 A/D - Modul,
;          gibt's das CAN-Tester-Script 'EA515_4DA_4AD_EMV_Test.cts' !
;     Das E/A515 - 4D/A (4*analog-OUT) muss
;     auf CANopen-Node-ID #2 gesetzt werden,
;     sonst gibt's Kollisionen mit dem Modul
;     E/A515 - 4A/ (mit  Node-ID #1)  !
;

Neustart:

;-- Einstellung Variablen -------------------------------------
@N=2       ; Node-ID (==DIP-Schalter-Adresse) vom E/A515 4A/D (4 * An.-In)
@N2=3      ; Note-ID (==DIP-Schalter-Adresse) vom E/A515 4D/A (4 * An.-Out)
@P =$180+N ; Identifier fuer PDO EA515 4A/D -> PC (Anfordern PER RTR !!)
@P2=512+N2 ; Identifier fuer PDO PC -> EA515 4D/A
@S=1536+N  ; SDO(rx) des E/A-Master-Moduls
@T=1408+N  ; SDO(tx) des E/A-Master-Moduls (!)
@Y= 1      ; Option: 0=ohne SYNC  1=mit SYNC
@L= 1      ; Option: 0=Laufl.aus  1=Laufl.an
@gosub ExtBoot
@goto  AIn_Test  ; test ANALOG INPUTS


;----- Communication Profile (DS301) ---------------------
(S) 40 05 10 00 00 00 00 00 ; read SYNC-Configuration            ($1005)
(S) 22 05 10 00 80 00 00 40 ; configure SYNC-Object (DS301 10-17)
(S) 40 06 10 00 00 00 00 00 ; read Communication-Cycle-Period    ($1006)
(S) 22 06 10 00 20 4E 00 00 ; set comm-cycle to 20000us
(S) 22 06 10 00 00 00 01 00
@sdo.w($1011.1, U32, 0x64616F6C) ; "load" DEFAULT PARAMETERS (!)  <<<<<<< ok for CANopen
;@sdo.w($1011.1, U32, 0x6C6F6164) ; "load" DEFAULT PARAMETERS (!)  <<<<<<< deliberately WRONG
@sdo.w($1010.1, U32, 0x65766173) ; "save" ALL PARAMETERS (!)      <<<<<<<

000 81 00   ; Node Reset
000 01 00   ; "Start Remode Nodes" (here: BROADCAST for all nodes)




;-------------- "transmit" - PDO (analoge und digitale Inputs) -------------
(S) 40 00 18 00 00 00 00 00 ; read nr C1800 entries (2 oder 4 ?)
(S) 40 00 18 01 00 00 00 00 ; read PDO ID of 1st tx pdo
(S) 40 00 18 02 00 00 00 00 ; read PDO transmission type
(S) 22 00 18 02 (#1) 00 00 00 ; write PDO transmission type
 ; (tr.type: 255=event  1..240=sync,  253=on RTR    [DS301 10-6] )
(S) 40 00 18 03 00 00 00 00 ; read PDO inhibit time
(S) 40 00 18 04 00 00 00 00 ; read PDO CMS priority

;----------- Objekte aus device profile (DS401) ----------------------------
@print   ; CAN Tester for windoze: press CTRL-F9 to continue from line of cursor
@print "---- Objects from DEVICE PROFILE DS401 -----"
@print "Device name = %s", sdo.r($1008.0,str) ; device name (as "visible string")
@print "NR_ANALOG_INPUTS = %ld",sdo.r($6401.0) ; read number of analog Inputs
@print "NR_ANALOG_OUTPUTS = %ld",sdo.r($6411.0) ; read number of analog Outputs (should fail)

@print "VALUE_ANALOG_IN1 = %ld",sdo.r($6401.1) ; read value of 1st analog Input  ($6401.1)
@print "ANALOG_TRIG_SEL1 = %ld",sdo.r($6421.1) ; read analog trigger selector    ($6421.1)
   ; INTERRUPT_TRIGGER_SELECTION Bits: 0=UpperLimit 1=LowerLimit 2=Delta,  rest unused
;@sdo.write($6421.1, U8, 0x04 )         ; write analog trigger selector
@print "GLBL_INTR_ENABLE = %ld",sdo.r($6423.0) ; are analog interrupt enabled? ($6423.1)
;@sdo.write($6423.1, U8, 1 )           ; enable analog interrupts (glob) ($6423.1)
;@sdo.write($6423.1, U8, 0 )           ; disable analog interrupts (glob) ($6423.1)
@print "UPPER_INTR_LIMIT = %ld",sdo.r($6424.1) ; read upper analog interrupt limit ($6424.1)
;@sdo.write($6424.1, U32, #32001 )      ; write upper analog intr limit    ($6424.1)
@print "LOWER_INTR_LIMIT = %ld",sdo.r($6425.1) ; read upper analog interrupt limit ($6425.1)
;@sdo.write($6425.1, I32, #-32001 )     ; write upper analog intr limit    ($6425.1)
@print "INPUT_INTR_DELTA = %ld",sdo.r($6426.1) ; read analog interrupt delta($6426.1)
;@sdo.write($6426.1, U32, #1023 )       ; write upper analog intr delta    ($6426.1)
@stop  ; end of access test for "DEVICE PROFILE AREA" (DS401)


;----------- "user specific", Codenummern sh. "Systemhandbuch" --------------
($700+N)rXX                       ; Anforderung Node-Guard-Status mit RTR
  ; Identification ....
@print "DRIVE=%ld",sdo.r(($5FFF-#93).0 ) ; READ Drive Ident (-> 5150 )
@print "DATE:%ld chrs..",sdo.r(($5FFF-#98).0 ) ; READ strlen(__DATE__)
@print "%c",sdo.r(($5FFF-#98).1 ) ; READ Compilation Date, __DATE__[0] (chr)
@print "%c",sdo.r(($5FFF-#98).2 ) ; READ Compilation Date, __DATE__[1] (chr)
@print "%c",sdo.r(($5FFF-#98).3 ) ; READ Compilation Date, __DATE__[2] (chr)
@print "%c",sdo.r(($5FFF-#98).4 ) ; READ Compilation Date, __DATE__[3] (chr)
@print "%c",sdo.r(($5FFF-#98).5 ) ; READ Compilation Date, __DATE__[4] (chr)
@print "%c",sdo.r(($5FFF-#98).6 ) ; READ Compilation Date, __DATE__[5] (chr)
@print "%c",sdo.r(($5FFF-#98).7 ) ; READ Compilation Date, __DATE__[6] (chr)
@print "%c",sdo.r(($5FFF-#98).8 ) ; READ Compilation Date, __DATE__[7] (chr)
@print "HW-MODEL=$%02lX",sdo.r(($5FFF-#18).0 ) ; READ  Hardware Model
  ; ($00=8IO, $20=AD4, $40=DA4)
@print "OPTIONS=$%lX",sdo.r( ($5FFF-#19).0 ) ; Read CFG_data.option_flags:
  ; b0=DS401 b1=COUNTER b2=?? b3=?? b4=SLAVE_ENABLE b5=AUTO_SAVE  b6=NO_NMT
@stop
($700+N)rXX                          ; Anforderung Node-Guard-Status per RTR
(S) 40 ($FF-#18)  5F 00  00 00 00 00 ; READ: Hardware Model
(S) 24 ($FF-#18)  5F 00  20 "MKT"    ; WRITE Hardware Model ($10=ADDA,$20=AD4)
(S) 40 ($FF-#19)  5F 00  00 00 00 00 ; READ: Option Flags
(S) 24 ($FF-#19)  5F 00  01 "MKT"    ; WRITE Option Flags   (mit Signatur)
@print "AD4-DIPCODE = 0x%lX",sdo.r(($5FFF-#513).0) ; READ: "AD4-DIPCODE" (4*Ain-Typ)
;   Wenn die angezeigten Analogwerte "vllig fr'n Ar... sind", 
;   dann hat bestimmt wieder jemand am DIP-Schalter rumgespielt
;   ohne der CPU die neuen Schalterstellungen per "Codestelle" 
;   C513 (Lenze-Slang) mitzuteilen. Oder das EEPROM ist Schrott.
@stop
(S) 24 ($5FFF-#513).w 0  00 00 00 00 ; WRITE: AD4-DIP:=4*Uin, alle unipolar(00)
(S) 24 ($5FFF-#513).w 0  55 00 00 00 ; WRITE: AD4-DIP:=4*Uin, alle bipolar(55)
(S) 24 ($5FFF-#513).w 0  AA 00 00 00 ; WRITE: AD4-DIO:=4*Iin, alle unipolar(AA)
(S) 24 ($5FFF-#513).w 0  FF 00 00 00 ; WRITE: AD4-DIO:=4*Iin, alle bipolar(FF)

  ; MANUFACTURER- (not !!"manufactory"!!)-specific debugging and misc stuff ....
@print "Raw ADC in0 = %ld",sdo.r(($5FFF-#514).0)  ; read AD4_raw_input[0=subindex1]
@print "Debug Val 1 = %ld",sdo.r(($5FFF-#128).0)  ; READ: debug1
@print "Debug Val 2 = %ld",sdo.r(($5FFF-#129).0)  ; READ: debug2
@print "PDO-ID-BASE = $%lX",sdo.r(($5FFF-#50).0)  ; read: PDO(rx) ID-base
@print "Error Flags = $%lX",sdo.r(($5FFF-#101).0) ; read: Error Flags
@print "MainLoops/s = %ld",sdo.r(($5FFF-#103).0)  ; read: main loops / second

  ; Other MANUFACTURER-specific stuff ("Code Numbers")...
@print "Extra TX Cycle = %ld",sdo.r(($5FFF-#14).0) ; Zusaetzlicher Sendezyklus
@sdo.write(($5FFF-#14).0, I16, #5) ; EXTRA TX-CYCLE ON [milliseconds]
@sdo.write(($5FFF-#14).0, I16, #0  ) ; EXTRA TX-CYCLE OFF
  ; Hinweis zum "Extra PDO TX Cycle" (Codestelle 14) :
  ; Im Handbuch vom alten EA515-8I/O hiess dieses Objekt 
  ;  "Sende-Zyklus der digitalen Eingaenge".
  ; Tatsaechlich ist damit der "Sende-PDO" des Moduls gemeint,
  ;   m.a.W. das Ding funktioniert auch mit ANALOGEN Eingaengen.
  ; Codestelle 14 = Objekt 0x5FF1 entspricht dem "PDO-EVENT-TIMER", 
  ;           den es in DS301 V3.0 LEIDER NOCH NICHT GAB !!!!!!!!!
  ; Der Timer in Codestelle 14 ist in MILLISEKUNDEN skaliert !
  ; Name dieser Codestelle seit November 2002:
  ;  "Zusaetzlicher Sende-Zyklus fuer TPDO"  bzw
  ;  "Extra PDO TX Cycle" .



;-- filter settings for analog inputs. subindex is the channel number (1..4).
;  Contents of "code location #13" ,  LOW-BYTE FOR AVERAGE-VALUE-SUMMANDS:
;     0 = no averaging, 4=average of the last 4 values, etc etc
;  Contents of "code location #13" ,  HIGH-BYTE FOR DIGITAL FILTER SELECION:
;     0x00 = no analog filter
;     0x1F = slowest possible filter, fg = approx 0.3 Hz 
@print "Filtercode Ch1 = %lX",sdo.r(($5FFF-#13).1) ; analog filter settings Ain#1
@sdo.write(($5FFF-#13).1, U16, 0x0000 )   ; no average, no filtering
@sdo.write(($5FFF-#13).1, U16, 0x0008 )   ; average over 8 values, no filtering
@sdo.write(($5FFF-#13).1, U16, 0xFFFF )   ; the slowest possible filter, same as :
@sdo.write(($5FFF-#13).1, U16, 0x1F08 )   ; average over 8 values + 0.3 Hz lowpass 
@sdo.write(($5FFF-#13).1, U16, 0x1E08 )   ; average over 8 values + 0.4 Hz lowpass
@sdo.write(($5FFF-#13).1, U16, 0x1408 )   ; average over 8 values + 0.6 Hz lowpass
@sdo.write(($5FFF-#13).1, U16, 0x1008 )   ; average over 8 values + 1.0 Hz lowpass
@sdo.write(($5FFF-#13).1, U16, 0x0808 )   ; average over 8 values + 3.5 Hz lowpass
@sdo.write(($5FFF-#13).1, U16, 0x0800 )   ; no average, only 3.5 Hz lowpass
@sdo.write(($5FFF-#13).1, U16, 0x0400 )   ; no average, only 4.5 Hz lowpass
@sdo.write(($5FFF-#13).1, U16, 0x0200 )   ; no average, only 6.0 Hz lowpass
@sdo.write(($5FFF-#13).1, U16, 0x0100 )   ; no average, only 6.7 Hz lowpass
@sdo.write(($5FFF-#13).1, U16, 0x0108 )   ; average over 8 values, 5.7 Hz lowpass (combined)


;-- calibration settings for analogue inputs. ----------------------------
;  Automatische Kalibrier-Prozedur siehe 515_CALI !
;     subindex 0      returns the array size
;     subindex 1 + (4*channel) + input_mode(0..3) returns offset or divisor8.
@stop
print "Num Calib Offsets =",sdo.r( ($5FFF-#520).0 ) ; read number of calibration offsets
print "Num Calib Divisors=",sdo.r( ($5FFF-#521).0 ) ; read number of calibration divisors
print "Calib Offset[1],unipolar = ",sdo.r( ($5FFF-#520).1 )  ; read offset voltage input#1, unipolar
print "Calib Offset[1],bipolar  = ",sdo.r( ($5FFF-#520).2 )  ; read offset voltage input#1, bipolar
print "Calib Offset[2],unipolar = ",sdo.r( ($5FFF-#520).3 )  ; read offset voltage input#1, unipolar
print "Calib Offset[2],bipolar  = ",sdo.r( ($5FFF-#520).4 )  ; read offset voltage input#1, bipolar
print "Calib Offset[3],unipolar = ",sdo.r( ($5FFF-#520).5 )  ; read offset voltage input#1, unipolar
print "Calib Offset[3],bipolar  = ",sdo.r( ($5FFF-#520).6 )  ; read offset voltage input#1, bipolar
print "Calib Offset[4],unipolar = ",sdo.r( ($5FFF-#520).7 )  ; read offset voltage input#1, unipolar
print "Calib Offset[4],bipolar  = ",sdo.r( ($5FFF-#520).8 )  ; read offset voltage input#1, bipolar
@stop ; the following didn't work anymore in 2012-06-04 :
sdo.w( ($5FFF-#520).1, I32, #00001 )  ; write offset voltage input#1, unipolar
(S) 23 ($5FFF-#520).w 02  #00002.L    ; write offset voltage input#1, bipolar
(S) 23 ($5FFF-#520).w 03  #00003.L    ; write offset current input#1, unipolar
(S) 23 ($5FFF-#520).w 04  #00004.L    ; write offset current input#1, bipolar
(S) 23 ($5FFF-#521).w 01  #255.L      ; write divis8 voltage input#1, unipolar
(S) 23 ($5FFF-#521).w 02  #256.L      ; write divis8 voltage input#1, bipolar
(S) 23 ($5FFF-#521).w 03  #257.L      ; write divis8 current input#1, unipolar
(S) 23 ($5FFF-#521).w 04  #258.L      ; write divis8 current input#1, bipolar

@I=1;
@repeat
(S) 23 ($5FFF-#520).w (I)  #000.L     ; set all analog offsets  to default
(S) 23 ($5FFF-#521).w (I)  #256.L     ; set all analog divisors to default
@I=I+1
@until (I>16)
@stop
;--- Aufruf spezieller Test-und Einstellprozeduren (Codenummern 2048...) -----
(S) 23 ($FF-#0)  57 00  3C "MKT"     ; call EAM_DefaultSettings(param...)
    ; $3C stellt DS401 + Mapping ein, vorher "Hardware Modell" einstellen!!!!
(S) 23 ($FF-#1)  57 00  01 "MKT"     ; call EAM_TestLoop(ctrl=1) (Lauflicht)
(S) 23 ($FF-#1)  57 00  02 "MKT"     ; call EAM_TestLoop(ctrl=2) (DIP->LEDs)

;====== Zustandsuebergaenge des EA-Moduls (Test) ==========================
000 01 00  ; "Start Remode Node" ("Node Start Protocol" in DS203-2 p.7)
000 02 00  ; "Stop Remote Node"
000 03 00  ; "Disconnect Remote Node"       (DS203-2 p.8)
000 80 00  ; "Enter Preoperational State"
000 81 00  ; Operational -> Initialisation (d.h. Reset)
#128 0     ; Sync-Telegramm
@stop


AIn_Test:  ;====== Analoge Eingnge abfragen (hier: anzeigen) ==============

; Prepare SCOPE/Plotter to show values from PDO :
@scope.show(2) ; REM show channel definition tab in the scope window
@scope.timing=0.005 ; REM set scope sampling interval (seconds)
  ; REM scope.ch[x]={ Name, Expression, ScaleMin, ScaleMax }
@scope.ch[0]={"PDO1_W0", canrx( P,0,I16), -32768, 32768 }
@scope.ch[1]={"PDO1_W1", canrx( P,16,I16), -32768, 32768 }
@scope.ch[2]={"PDO1_W2", canrx( P,32,I16), -32768, 32768 }
@scope.ch[3]={"PDO1_W3", canrx( P,48,I16), -32768, 32768 }
  ; REM -3dB-Linien ins Diagramm zeichnen ( pos und neg.)
  ; Diente im Mai 2005 zur Messung der Grenzfrequenzen
  ; der digitalen Filter im EA515-4A/D fuer ESD .
@scope.ch[4]={"m3dB_p", +0.707, -1.0, +1.0 }
@scope.ch[5]={"m3dB_n", -0.707, -1.0, +1.0 }
@scope.show(1) ; REM open the "plotter" tab in the scope window


; Open another window to show the analog inputs in NUMERICAL form
 OpenWindow( "E/A-Modul-Test : Analoge Eingnge",w=320,h=200)
 SetButton( 1, "<< &Neustart", goto Neustart  )
 SetButton( 2, "- 9 V", (P2) (-#29410).w (-#29410).w (-#29410).w (-#29410).w ) ; alle Analog-Outputs auf MINUS  9 VOLT
 SetButton( 3, "+ 9 V", (P2) (+#29410).w (+#29410).w (+#29410).w (+#29410).w ) ; alle Analog-Outputs auf PLUS   9 VOLT
 SetButton( 4, "&Rampe >>",   goto RampUp )
 ClearScreen() : SetFont("Arial",20,0)

000 01 00  ; Pre-Operational -> Operational

 ; Fuer den EMV-Test: Zusammenschaltung eines EA515-4A/D mit einem EA515-4D/A :
 ;   (alle OUTPUTS auf + oder - 10 V taugt nix, denn damit hngt der ADC "am Poller",
 ;    und die LSBits wackeln nicht mehr !)
(P2) (-#16383).w (-#16383).w (-#16383).w (-#16383).w ; alle Analog-Outputs auf MINUS  5 VOLT
(P2) (-#29410).w (-#29410).w (-#29410).w (-#29410).w ; alle Analog-Outputs auf MINUS  9 VOLT
(P2) (-#32767).w (-#32767).w (-#32767).w (-#32767).w ; alle Analog-Outputs auf MINUS 10 VOLT
(P2) (+#32767).w (+#32767).w (+#32767).w (+#32767).w ; alle Analog-Outputs auf PLUS  10 VOLT
(P2) (+#29410).w (+#29410).w (+#29410).w (+#29410).w ; alle Analog-Outputs auf PLUS   9 VOLT


TestL1:
($700+N)rXX        ; Anforderung Node-Guard-Status via RTR
FastLoop:
   (P)rXX             ; Anforderung PDO-Telegramm via RTR (wichtig fr Analoge Inputs)
   @gosub ShowAnalogValues ; 4 analoge Inputs NUMERISCH anzeigen
@goto FastLoop

ShowAnalogValues:
   MoveTo(16,8)  ; Anzeige mit Skalierung : 10 V / 32768 = 0.000306016
   print( "An.-Input 1 : %7.3f V  ", 0.000306016 * canrx( P, 0,I16) );
   print( "An.-Input 2 : %7.3f V  ", 0.000306016 * canrx( P,16,I16) );
   print( "An.-Input 3 : %7.3f V  ", 0.000306016 * canrx( P,32,I16) );
   print( "An.-Input 4 : %7.3f V  ", 0.000306016 * canrx( P,48,I16) );
return

RampUp:      ; hnliche Schleife, aber mit RAMPENFUNKTION fr die Outputs
 OpenWindow( "E/A-Modul-Test : Rampe fr analoge Ausgnge",w=320,h=200)
 SetButton( 1, "<< &Zurck", goto AIn_Test   )
 SetButton( 2, "&Weiter >>", goto StopAInTest)
 ClearScreen() : SetFont("Arial",20,0)
 @OutW = 0    ; Startwert fr alle 4 analogen Ausgnge
RampLoop:
   (P2) (OutW).w (OutW).w (OutW).w (OutW).w ; alle 4 Analog-Outputs ansteuern
   @OutW = (OutW + 333) & 0x0FFFF   ; Rampe von 0x0000 ... 0xFFFF fr A.Out
   (P)rXX ; Anforderung PDO-Telegramm via RTR (wichtig fr Analoge Halluzinelle)
   @gosub ShowAnalogValues ; 4 analoge Inputs NUMERISCH anzeigen
@goto RampLoop

StopAInTest: ; Stop the analog-input-test (and hide its windows) ...
@scope.show(0) ; REM open the "plotter" tab in the scope window
CloseWindow()  ; Benutzerdefiniertes Fenster schliessen (falls noch offen)
 print "Programmende - Neustart mit F9 !"
stop


ExtBoot:     ; Unterprogramm "Bootup MIT Nodeguarding und SYNC"
000 80 00    ; Enter Pre-Operational State
000 03 00    ; Disconnect -> Antwort "#2022"=identify node
($700+N)rXX  ; Anforderung Node-Guard-Status
(#2026) 04 (N) 00 00 00 00 00 00 ; Connect Remote Node ("Teil 1")
(#2026) 06 00  FF 00 00 00 00 00  ; "Identify Remote Nodes" (!!??!!)
(#2026) 02 (N) (N) 07 00 10 02 02 ; Node Guarding Vorbereitung [203-2p4],"T.2"
(#2026) 03 (N) 01 00 00 00 00 00  ; Prepare Remote Node
@return  ; Ende "ExtBoot"
; <EOF>