;-- 515_4AOU (Analog-Tests fuer MKTs EA515-Modul 4*A.out) Stand: 20.Nov.2002 ---
;     Mit Tests fuer eine "Extrawurst" (Sondersoftware 11070)
;     Nur mit CAN-TESTER FUER WINDOZE LAUFFAEHIG !!!!!!!
;     Ablage des Originals: //WoBu5/c/CBProj/CanTest/Programs/515_4aou.txt
;
; Hinweis: Fr einen EMV-Test anno 2012, mit 4 D/A + 4 A/D - Modul,
;          gibt's das CAN-Tester-Script 'EA515_4DA_4AD_EMV_Test.cts' !
;     Das E/A515 - 4D/A (4*analog-OUT) muss
;     auf CANopen-Node-ID #2 gesetzt werden,
;     sonst gibt's Kollisionen mit dem Modul
;     E/A515 - 4A/ (mit  Node-ID #1)  !
;
;
; CAN-Sende-Intervall fr den CAN-Tester einstellen. Einheit : SEKUNDEN .
@tx_interval=20e-3   : REM 20 ms pro Telegramm muss reichen


;-- Einstellung Variablen (auch fuer Watches, stehen in 515_4A_W)------------
@N=2       ; Node-ID (==DIP-Schalter-Adresse)
    ; Achtung: Knotennummer auch unter "Settings..SDO client" einstellen !
@J=384+N   ; Identifier f. PDO EA->Master (Inputs,Lenze: 767+N, DS401:384+N)
@P=512+N   ; Identifier f. PDO Master->EA (Outputs,Lenze: 768+N, DS401:512+N)
@S=1536+N  ; SDO(rx) des E/A-Master-Moduls
@T=1408+N  ; SDO(tx) des E/A-Master-Moduls (!)
@Y= 1      ; Option: 0=ohne SYNC  1=mit SYNC
@L= 1      ; Option: 0=Laufl.aus  1=Laufl.an
@goto  LaufLicht
@set_scope.timing 20
@set_scope(5).range 19800 20200
@set_scope(5).range -32768 32767
;----- Communication Profile (DS301) ---------------------
(S) 40 05 10 00 00 00 00 00 ; read SYNC-Configuration            ($1005)
(S) 22 05 10 00 80 00 00 40 ; configure SYNC-Object (DS301 10-17)
(S) 40 06 10 00 00 00 00 00 ; read Communication-Cycle-Period    ($1006)
(S) 22 06 10 00 20 4E 00 00 ; set comm-cycle to 20000us
(S) 22 06 10 00 00 00 01 00
(S) 22 $1010.w 1 "save"     ; "save" Parameters ($1010.1) "save"=73 61 76 65h
(S) 22 $1011.w 1 "load"     ; "load" default params ($1011.1) "load"=6C 6F 61 64

;-------------- "transmit" - PDO (analoge und digitale Inputs) -------------
(S) 40 $1800.w  0  #0.L     ; read nr C1800 entries (2 oder 4 ?)
(S) 40 $1800.w  1  #0.L     ; read PDO ID of 1st tx pdo
(S) 40 $1800.w  2  #0.L     ; read PDO transmission type
(S) 22 $1800.w  2  #255.L   ; write PDO transmission type
 ; (tr.type: 255=event  1..240=sync,  253=on RTR    [DS301 10-6] )
(S) 40 $1800.w  3  #0.L     ; read PDO inhibit time NOT IMPLEMENTED,ERROR
(S) 40 $1800.w  4  #0.L     ; read PDO CMS priority NOT IMPLEMENTED,ERROR

;-------------- "receive" - PDO (analoge Outputs) -----------------
(S) 40 $1400.w  0  0.L  ; read nr C1400 entries (2 oder 4 ?)
(S) 40 $1400.w  1  0.L  ; read PDO ID of 1st tx pdo (->0x200+Node#)
(S) 40 $1400.w  2  0.L  ; read PDO transmission type (-> 0xFF=async)
(S) 40 $1400.w  3  0.L  ; read PDO inhibit time NOT IMPLEMENTED,error
(S) 40 $1400.w  4  0.L  ; read PDO CMS priority NOT IMPLEMENTED,error
(S) 40 $1600.w  0  0.L  ; read number of mapped application objects in PDO
(S) 40 $1600.w  1  0.L  ; read PDO mapping of 1st application object
(S) 40 $1600.w  2  0.L  ; read PDO mapping of 2nd application object
(S) 40 $1600.w  3  0.L  ; read PDO mapping of 3rd application object
(S) 40 $1600.w  4  0.L  ; read PDO mapping of 4th application object

;----------- Objekte aus device profile (DS401) ----------------------------
@print "NR_AN_AIN=%ld",sdo.r($6401.0) ; read number of analog Inputs
@print "NR_AN_OUT=%ld",sdo.r($6411.0) ; read number of analog Outputs
@print "AN_INPUT1=%ld",sdo.r($6411.1, I16) ; read(!) value of 1st analog Output
@print "AN_INPUT2=%ld",sdo.r($6411.2, I16) ; read(!) value of 2nd analog Output
@print "AN_INPUT3=%ld",sdo.r($6411.3, I16) ; read(!) value of 3rd analog Output
@print "AN_INPUT4=%ld",sdo.r($6411.4, I16) ; read(!) value of 4th analog Output
@sdo.write($6411.1, I16, +32767)      ; write to 1st analog output per SDO..
@sdo.write($6411.2, I16, +16383)      ; write to 2nd analog output
@sdo.write($6411.3, I16, -16383)      ; write to 3rd analog output
@sdo.write($6411.4, I16, -32767)      ; write to 4th analog output

@sdo.write($6411.1, I16, +32767)  ; write   1st analog Output ($6411.1) +max K1
@sdo.write($6411.1, I16, -32768)  ; write   1st analog Output ($6411.1) -max K1
@sdo.write($6411.1, I16,   0   )  ; write   1st analog Output ($6411.1) Null K1
@sdo.write($6411.2, I16, +32767)  ; write   2nd analog Output ($6411.2) +max K2
@sdo.write($6411.2, I16, -32768)  ; write   2nd analog Output ($6411.2) -max
@sdo.write($6411.2, I16,   0   )  ; write   2nd analog Output ($6411.2) Null 
@sdo.write($6411.3, I16, +32767)  ; write   3rd analog Output ($6411.3) +max K3
@sdo.write($6411.3, I16, -32768)  ; write   3rd analog Output ($6411.3) -max
@sdo.write($6411.3, I16,   0   )  ; write   3rd analog Output ($6411.3) Null
@sdo.write($6411.4, I16, +32767)  ; write   4th analog Output ($6411.4) +max K4
@sdo.write($6411.4, I16, -32768)  ; write   4th analog Output ($6411.4) -max
@sdo.write($6411.4, I16,   0   )  ; write   4th analog Output ($6411.4) Null 

(S) 40 $6443.w 0 #0.L     ; read "Output Fault Mode": Number of Outputs
(S) 40 $6443.w 1 #0.L     ; read ouput fault mode for 1st AOUT 0=no change
(S) 22 $6443.w 1 #1.L     ; write output fault mode " "        1=revert
(S) 40 $6444.w 1 #0.L     ; read output fault value for 1st AOUT, unconv.
(S) 22 $6444.w 1 #32767.L ; write output fault value for 1st AOUT, unconv.
(S) 22 $6443.w 1 #1.L     ; write output fault mode for channel 1
(S) 22 $6443.w 2 #1.L     ; write output fault mode for channel 2
(S) 22 $6443.w 3 #1.L     ; write output fault mode for channel 3
(S) 22 $6443.w 4 #1.L     ; write output fault mode for channel 4
(S) 22 $6444.w 1 $7FFF.L  ; write output fault value for channel 1
(S) 22 $6444.w 2 $8001.L  ; write output fault value for channel 2
(S) 22 $6444.w 3 #00000.L ; write output fault value for channel 3
(S) 22 $6444.w 4 #00000.L ; write output fault value for channel 4

(S) 22 $1010.w 1 "save"   ; "save" Parameters ($1010.1) in EEPROM

;----------- "user specific", Codenummern sh. "Systemhandbuch" --------------
($700+N)rXX                       ; Anforderung Node-Guard-Status mit RTR
@print "DRIVE=%ld",sdo.r(($5FFF-#93).0 ) ; READ Drive Ident (-> 5150 )
@print "SOFTW=%ld",sdo.r(($5FFF-#99).0)  ; SW-Version (alt:Zeichen neu:FIX32)
@print "DATE:%ld chrs..",sdo.r(($5FFF-#98).0 ) ; READ strlen(__DATE__)
@print "%c",sdo.r(($5FFF-#98).1 ) ; READ Compilation Date, __DATE__[0] (chr)
@print "%c",sdo.r(($5FFF-#98).2 ) ; READ Compilation Date, __DATE__[1] (chr)
@print "%c",sdo.r(($5FFF-#98).3 ) ; READ Compilation Date, __DATE__[2] (chr)
@print "%c",sdo.r(($5FFF-#98).4 ) ; READ Compilation Date, __DATE__[3] (chr)
@print "%c",sdo.r(($5FFF-#98).5 ) ; READ Compilation Date, __DATE__[4] (chr)
@print "%c",sdo.r(($5FFF-#98).6 ) ; READ Compilation Date, __DATE__[5] (chr)
@print "%c",sdo.r(($5FFF-#98).7 ) ; READ Compilation Date, __DATE__[6] (chr)
@print "%c",sdo.r(($5FFF-#98).8 ) ; READ Compilation Date, __DATE__[7] (chr)
@print "HW-MODEL=$%02lX",sdo.r(($5FFF-#18).0 ) ; READ  Hardware Model
  ; ($00=8IO, $40=DA4)
@print "OPTIONS=$%lX",sdo.r( ($5FFF-#19).0 ) ; Read CFG_data.option_flags:
  ; b0=DS401 b1=COUNTER b2=?? b3=?? b4=SLAVE_ENABLE b5=AUTO_SAVE  b6=NO_NMT
(S) 24 ($5FFF-#18).w  0  40 "MKT" ; WRITE Hardware Model($10=ADDA,$20=AD4)
(S) 24 ($5FFF-#19).w  0  01 "MKT" ; WRITE Option Flags   (mit Signatur)
@print "Nr_Aout=%ld",sdo.r(($5FFF-#640).0 )  ; read number of analogue outputs
(S) 24 ($5FFF-#640).w 0  #0.L     ; WRITE: DA4-Register: nr of subindices
@sdo.write(($5FFF-#640).1, I16, +32767)      ; WRITE analog value for 1st output
@sdo.write(($5FFF-#640).1, I16, -32768)      ; WRITE analog value for 1st output
@print "DAC-Reg1=%ld",sdo.r(($5FFF-#640).1)  ; read value of 1st DAC-Register
@print "DAC-Reg2=%ld",sdo.r(($5FFF-#640).2)  ; read value of 2nd DAC-Register
@print "DAC-Reg3=%ld",sdo.r(($5FFF-#640).3)  ; read value of 3rd DAC-Register
@print "DAC-Reg4=%ld",sdo.r(($5FFF-#640).4)  ; read value of 4th DAC-Register
(S) 40 ($5FFF-#128).w 0  #0.L     ; READ: debug1
(S) 40 ($5FFF-#129).w 0  #0.L     ; READ: debug2
(S) 40 ($5FFF-#10).w  0  #0.L     ; read: port directions
(S) 40 ($5FFF-#50).w  0  #0.L     ; read: PDO(rx) ID-base
(S) 40 ($5FFF-#101).w 0  #0.L     ; read: Error Flags
(S) 40 ($5FFF-#102).w 0  #0.L     ; slave check
(S) 40 ($5FFF-#103).w 0  #0.L     ; read: main_loops/second (26.3.99: "2615")

(S) 22 $1010.w 1 "save"           ; "save" Parameters ($1010.1) in EEPROM

;--- Aufruf spezieller Test-und Einstellprozeduren (Codenummern 2048...) -----
(S) 24 ($5FFF-#18).w    0  40 "MKT"  ; write Hardware Model ($40= "DA4")
(S) 23 ($5FFF-#2048).w  0  3C "MKT"  ; call EAM_DefaultSettings(param...)
    ; $3C stellt DS401 + Mapping ein, vorher "Hardware Modell" einstellen!!!!
(S) 23 ($5FFF-#2049).w  0  01 "MKT"  ; call EAM_TestLoop(ctrl=1) (Lauflicht)
(S) 23 ($5FFF-#2049).w  0  02 "MKT"  ; call EAM_TestLoop(ctrl=2) (DIP->LEDs)

;=====  Objekte nach DS301: =======================
(S) 40 1003.w 0 0.L   ; "predefined error field"
(S) 40 1003.w 1 0.L   ; 1st entry in error field.

;====== Zustandsuebergaenge des EA-Moduls (Test) ============================
000 01 00  ; "Start Remode Node" ("Node Start Protocol" in DS203-2 p.7)
000 02 00  ; "Stop Remote Node"
000 03 00  ; "Disconnect Remote Node"       (DS203-2 p.8)
000 80 00  ; "Enter Preoperational State"
000 81 00  ; Operational -> Initialisation (d.h. Reset)
#128 0     ; Sync-Telegramm
@stop

LaufLicht:  ;====== Erzeugen von "Rampen" an den analogen Ausgaengen =======
 @gosub ExtBoot ; "Extended Bootup" wichtig fuer Node-Guarding.
 000 01 00  ; Modul von Pre-Operational -> Operational schalten, PDOs aktiv.
Lauf1:      ; 4 * 16 Bit, alle Aout-Kanaele, "Analog-Lichtshow" mit je 2LEDs
 @I = I-3333 ; "aktueller" Analogwert, POSITIV=rote LED,  NEGATIV=gruene LED !
 (P) (I).w (I+#5000).w (I+#10000).w (I+#15000).w
 ($700+N)rXX ; Anforderung Node-Guard-Status via RTR
@goto Lauf1

;--- Test fuer Sonderfirmware mit "Extrawurst" (EW) +-16383 fuer PDO, Art11070
EWtest:
(P) 0.w 0.w 0.w 0.w    ; alle Analogoutputs auf NULL
(P) (-#08191).w (-#08191).w (-#08191).w (-#08191).w ; EW:alle auf MINUS 5 VOLT
(P) (-#16383).w (-#16383).w (-#16383).w (-#16383).w ; EW:alle auf MINUS 10 VOLT
(P) (+#08191).w (+#08191).w (+#08191).w (+#08191).w ; EW:alle auf PLUS  5 VOLT
(P) (+#16383).w (+#16383).w (+#16383).w (+#16383).w ; EW:alle auf PLUS  10 VOLT
@goto EWtest


ExtBoot:     ; Unterprogramm "Bootup MIT Nodeguarding und SYNC"
000 80 00    ; Enter Pre-Operational State
000 03 00    ; Disconnect -> Antwort "#2022"=identify node
($700+N)rXX  ; Anforderung Node-Guard-Status
(#2026) 04 (N) 00 00 00 00 00 00 ; Connect Remote Node ("Teil 1")
(#2026) 06 00  FF 00 00 00 00 00  ; "Identify Remote Nodes" (!!??!!)
(#2026) 02 (N) (N) 07 00 10 02 02 ; Node Guarding Vorbereitung [203-2p4],"T.2"
(#2026) 03 (N) 01 00 00 00 00 00  ; Prepare Remote Node
@return  ; Ende "ExtBoot"

; <EOF>
