; BucherCityCatTest.TXT:   Testprogramm zum Ansteuern der "BUCHER-KONSOLE" (fuer CityCat).
;  Lauffhig mit CAN TESTER FR WINDOWS - Start mit  F9  !
;  Ablage: <WoBu3>C:\cbproj\CanTest\Programs\BucherCityCatTest.TXT
;  Stand:  2006-05-24    Autor: W.Buescher
; Telegramme: RPDO $201+X: 1.Word=LEDs        2.Word=Hintergrund 3.Word=DigOut
;             TPDO $181+X: 1.Word=Tasten-Bits 2.Word=Joystick    3.Word=DigIn
; Baudrate: siehe Ltkleckse; manchmal 100, manchmal 250 kBit/sec ! 

OnError goto Verflixt ; Sprung falls irgendwas schiefgeht

ClearVars()     ; alte Variableninhalte lschen
; Identifier der verwendeten CAN-Telegramme definieren .
;  Bei BUCHER ist "X"=dez.16,17,18,19; je nach DIP-Schalter...
@D = 12 ; per DIP-Schalter eingestellter "CANopen-Node-ID" (1...255; Bucher: 12)
@R = $200+D ; RPDO1 (aus Sicht der Tastatur)
@T = $180+D ; TPDO1 (aus Sicht der Tastatur)

Neustart:
@tx_interval(0.05)   ; define TX-interval IN SECONDS (and program execution speed)
OpenWindow("Test \"Bucher-Konsole\" / CityCat V1.0",w=500,h=320)
SetFont("Arial",20):ClearScreen()
000 01 00    ; NMT: Start all CANopen nodes
ClearScreen():print( "Hintergrundbeleuchtung an (max).." )
(R)  $0000.w $000F.w $0000.w   ; nur Hintergrund (Stufe 0..15)
@delay 1
ClearScreen():print( "Hintergrundbeleuchtung an (mittel).." )
(R)  $0000.w $0007.w $0000.w   ; nur Hintergrund (Stufe 0..15)
@delay 1
ClearScreen():print( "Hintergrundbeleuchtung aus ." )
(R)  $0000.w $0000.w $0000.w   ; einige LEDs ohne Hintergrund
@delay 1
ClearScreen():print( "Pieper an (laut) .." )
(R)  $0000.w $0F00.w $0000.w   ; maximale Lautstaerke bei RESONANZ
@delay 1
ClearScreen():print( "Pieper an (mittellaut) .." )
(R)  $0000.w $0700.w $0000.w   ; 50 Prozent Lautstrke 
@delay 1
ClearScreen():print( "Pieper an (leise) .." )
(R)  $0000.w $0100.w $0000.w   ; 7 Prozent Lautstrke
@delay 1
ClearScreen():print( "Pieper an (hoher Ton) .." )
(R)  $0000.w $1F00.w $0000.w   ; Frequenz   in Word[1] Bits 15..12
(R)  $0000.w $2F00.w $0000.w
(R)  $0000.w $4F00.w $0000.w
(R)  $0000.w $6F00.w $0000.w
(R)  $0000.w $8F00.w $0000.w
(R)  $0000.w $AF00.w $0000.w
(R)  $0000.w $CF00.w $0000.w
(R)  $0000.w $EF00.w $0000.w
(R)  $0000.w $FF00.w $0000.w   ; Frequenz   in Word[1] Bits 15..12
@delay 1
ClearScreen():print( "Pieper an (tiefer Ton) .." )
(R)  $0000.w $1F00.w $0000.w   ; Frequenz   in Word[1] Bits 15..12
@delay 1
ClearScreen():print( "Pieper aus ." )
(R)  $0000.w $0000.w $0000.w   ; Lautstaerke in Word[1] Bits 11..8
@delay 1


ClearScreen()   ; nchste Anzeigeseite vorbereiten...
SetButton(1,"&Neustart",goto Neustart)
SetButton(2,"&Beenden", goto Beenden)
SetFont("Arial",8):MoveTo(0,10)
; Baudrate und Node-ID anzeigen (hufige Fehlerursache!) :
print( "CAN-Baudrate = %ld kBit/sec   Node-ID=%ld",can.baudrate,D)
SetFont("Arial",15,7):MoveTo(20,200)
print( "Hinweis: gedrckte Tasten knnen\r\nbei diesem Gert nicht aufleuchten ! " )
@tx_interval(0.01)  ; define TX-interval IN SECONDS (and execution speed)
000 01 (D)  ; NMT: Start THIS CANopen node (and clear timeout-flag)

Loop1: ; Schleife 1 : fuer BUCHER-Konsole "CityCat" ...
 @KeyMatrixBits = canrx(T,0,U16,0)  ; 16-bit Tastenzustnde lesen
 @JoystickBits  = canrx(T,16,U16,0) ; 16-bit Joystick-Kontakte
 @DigitalInputs = canrx(T,32,U16,0) ; 16-bit digitale Eingnge
 @AnalogInA = canrx(T,48,BYTE,0)    ; 8-bit Analogeingang A
 @AnalogInB = canrx(T,56,BYTE,0)    ; 8-bit Analogeingang B
 @L=0 ; Akustische Rckkoppling der Tasten+Eingnge auf Pieper..
 @if((KeyMatrixBits+DigitalInputs)>0) @L=0x17
 (R) (KeyMatrixBits).w (H/4) (L) 0.w 0.w ; PDO-Telegramm senden
 @S=L+1            ; Ansteuerung der 7-Segment-Anzeige via LAUFLICHT
 @H=(H+1)&63       ; Hintergrundbeleuchtung aendern
 SetFont("Courier New",26):MoveTo(0,40)
 print "Tast.: %14b",KeyMatrixBits )  ; 14 Tasten als Binrzahl
 print "Joys.: %16b",JoystickBits  )  ; ehemals Joystick-Kontakte (Rsv)
 print "An.In: A=%03ld B=%03ld",AnalogInA,AnalogInB) ; analoge Inputs
 print "DigIn: %16b",DigitalInputs )  ; digitale Inputs binr
@goto Loop1


Loop2: ; Schleife 2 : fuer SAHM-Tastatur mit ERWEITERUNG1 (2*7Segment)
 @KeyMatrixBits = canrx(T,0,I16)  ; 16-bit Tastenzustnde lesen
 @delay(0.05)      ; Sendezyklus der Testschleife etwas bremsen !
 (R)  (KeyMatrixBits).w (H).w #0.w (S).w
 @S=S+1            ; Ansteuerung der Siebensegment-Anzeige via LAUFLICHT
 @H=(H+1)&15       ; Hintergrundbeleuchtung aendern
@goto Loop2

;--------- Planmaessiges Ende des Tests... ----------------------
Beenden:
CloseWindow()
print "Programmende - Neustart mit F9"
stop

;--------- Bei Fehlern... ---------------------------------------
Verflixt:
 OpenWindow( "CAN-Test : FEHLER ! ",w=400,h=200,bc=red)
 SetFont("Arial",8) : MoveTo(8,4) 
 print( "Fehlercode %ld in Programmzeile %ld", ErrorInfo.code, ErrorInfo.line )
 print( ErrorInfo.text )
 SetFont("Arial",11,2) : MoveTo(8,40) 
 print "- CAN-Baudrate berprfen (momentan %ld kBit/sec)",can.baudrate
 print "- Knotennummer berprfen (momentan #%ld )",D
 print "- die verdammten Kabel berprfen"
 print "- die DIP-Schalter richtig einstellen"
 SetButton( 1,"&Nochmal versuchen",  goto Neustart )
 SetButton( 2,"&Abbrechen",  goto Abbruch )
Fehlerschleife:
goto Fehlerschleife
Abbruch:  ; ABBRUCH im Fehlerfall, ohne nochmaligen CAN-Sendeversuch !
 CloseWindow()  ; Benutzerdefiniertes Fenster schliessen (falls noch offen)
 print "Programmabbruch - Neustart mit F9 !"
@stop


; EOF