; BucherTastaturTest.TXT:   Testprogramm zum Ansteuern der "BUCHER-TASTATUR".
;  Lauffhig mit CAN TESTER FR WINDOWS - Start mit  F9  !
;  Ablage: <WoBu3>C:\cbproj\CanTest\Programs\BucherTastaturTest.TXT
;  Stand:  2006-04-26    Autor: W.Buescher
; Telegramme: PDO $201+X: 1.Word=LEDs        2.Word=Hintergrund 3.Word=DigOut
;             PDO $181+X: 1.Word=Tasten-Bits 2.Word=Joystick    3.Word=DigIn
; Baudrate: Manchmal 100, manchmal 250 kBit/sec ! !

OnError goto Verflixt ; Sprung falls irgendwas schiefgeht

ClearVars()     ; alte Variableninhalte lschen
; Identifier der verwendeten CAN-Telegramme definieren .
;  Bei BUCHER ist "X"=dez.16,17,18,19; je nach DIP-Schalter...
@D = 0  ; per DIP-Schalter eingestellter "Adress-Offset" (BUCHER: 0..3)
@R = $201+#16+D ; RPDO1 (aus Sicht der Tastatur) BUCHER:$211, BLE:$211
@T = $181+#16+D ; TPDO1 (aus Sicht der Tastatur) BUCHER:$191, BLE:$191

Neustart:
OpenWindow("Bucher-Tastatur-Test",w=500,h=300)
SetFont("Arial",20):ClearScreen()
print( "Alles an..." )
(R)  $ffff.w $ffff.w $ffff.w   ; alles an
@delay(1)    ; Verzoegerung seit 2006-04 in SEKUNDEN (SI-Einheit)
ClearScreen():print( "Alles aus.." )
(R)  $0000.w $0000.w $0000.w   ; alles aus
@delay 1
ClearScreen():print( "Nur Hintergrund.." )
(R)  $0000.w $0003.w $0000.w   ; nur Hintergrund (Stufe 0..15)
@delay 1
ClearScreen():print( "ohne Hintergrund.." )
(R)  $aaaa.w $0000.w $0000.w   ; einige LEDs ohne Hintergrund
@delay 1
ClearScreen():print( "mit Hintergrund.." )
(R)  $aaaa.w $0004.w $0000.w   ; einige LEDs mit  Hintergrund
@delay 1

ClearScreen() 
SetButton(1,"&Neustart",goto Neustart)
SetButton(2,"&Beenden", goto Beenden)
SetFont("Arial",8):MoveTo(0,10)
print( "CAN-Baudrate = %ld kBit/sec",can.baudrate ) ; 100 oder 250 kBit/sec ?
SetFont("Arial",15,7):MoveTo(10,190)
print( " gedrckte Tasten mssen HELL aufleuchten ! " )


Loop1: ; Schleife 1 : fuer BUCHER-Tastatur.
       ; Funktion: Hintergrundhelligkeit aendert sich staendig,
       ; beim Druecken einer Taste muss diese hell aufleuchten.
 @KeyMatrixBits = canrx(T,0,I16,0)  ; 16-bit Tastenzustnde lesen
 @JoystickBits  = canrx(T,16,I16,0) ; 16-bit Joystick-Kontakte
 @DigitalInputs = canrx(T,32,I16,0) ; 16-bit digitale Eingnge
 @delay(0.02)      ; Sendezyklus der Testschleife etwas bremsen !
 (R) (KeyMatrixBits).w (H/4).w $0000.w      ; PDO-Telegramm senden
 @S=L+1            ; Ansteuerung der 7-Segment-Anzeige via LAUFLICHT
 @H=(H+1)&63       ; Hintergrundbeleuchtung aendern
 SetFont("Courier New",26):MoveTo(0,40)
 print "Tast.: %16b",KeyMatrixBits )  ; Matrixbits als Binrzahl
 print "Joys.: %16b",JoystickBits  )  ; Joystick-Kontakte..
 print "DigIn: %16b",DigitalInputs )  ; digitale Inputs auch
@goto Loop1


Loop2: ; Schleife 2 : fuer SAHM-Tastatur mit ERWEITERUNG1 (2*7Segment)
 @KeyMatrixBits = canrx(T,0,I16)  ; 16-bit Tastenzustnde lesen
 @delay(0.05)      ; Sendezyklus der Testschleife etwas bremsen !
 (R)  (KeyMatrixBits).w (H).w #0.w (S).w
 @S=S+1            ; Ansteuerung der Siebensegment-Anzeige via LAUFLICHT
 @H=(H+1)&15       ; Hintergrundbeleuchtung aendern
@goto Loop2

;--------- Planmaessiges Ende des Tests... ----------------------
Beenden:
CloseWindow()
print "Programmende - Neustart mit F9"
stop

;--------- Bei Fehlern... ---------------------------------------
Verflixt:
 OpenWindow( "CAN-Test : FEHLER ! ",w=400,h=200,bc=red)
 SetFont("Arial",8) : MoveTo(8,4) 
 print( "Fehlercode %ld in Programmzeile %ld", ErrorInfo.code, ErrorInfo.line )
 print( ErrorInfo.text )
 SetFont("Arial",11,2) : MoveTo(8,40) 
 print "- CAN-Baudrate berprfen (momentan %ld kBit/sec)",can.baudrate
 print "- Knotennummer berprfen (momentan #%ld )",sdo.node
 print "- die verdammten Kabel berprfen"
 print "- die DIP-Schalter richtig einstellen"
 SetButton( 1,"&Nochmal versuchen",  goto Neustart )
 SetButton( 2,"&Abbrechen",  goto Abbruch )
Fehlerschleife:
goto Fehlerschleife
Abbruch:  ; ABBRUCH im Fehlerfall, ohne nochmaligen CAN-Sendeversuch !
 CloseWindow()  ; Benutzerdefiniertes Fenster schliessen (falls noch offen)
 print "Programmabbruch - Neustart mit F9 !"
@stop


; EOF